"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerParticipant(ProtocolElement):
    """
    This defines a Cancer Participant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "germlineSamples",
        "individualId",
        "matchedSamples",
        "readyForAnalysis",
        "sex",
        "tumourSamples",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3

        return {
            "consentStatus": participant_1_0_3.ConsentStatus,
            "germlineSamples": participant_1_0_3.GermlineSample,
            "matchedSamples": participant_1_0_3.MatchedSamples,
            "tumourSamples": participant_1_0_3.TumourSample,
            "versionControl": participant_1_0_3.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3

        return {
            "sex": participant_1_0_3.Sex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3

        return {
            "org.gel.models.participant.avro.ConsentStatus": participant_1_0_3.ConsentStatus,
            "org.gel.models.participant.avro.GermlineSample": participant_1_0_3.GermlineSample,
            "org.gel.models.participant.avro.MatchedSamples": participant_1_0_3.MatchedSamples,
            "org.gel.models.participant.avro.Sex": participant_1_0_3.Sex,
            "org.gel.models.participant.avro.TumourSample": participant_1_0_3.TumourSample,
            "org.gel.models.participant.avro.VersionControl": participant_1_0_3.VersionControl,
            "org.gel.models.participant.avro.CancerParticipant": participant_1_0_3.CancerParticipant,
        }

    __slots__ = [
        "germlineSamples",
        "individualId",
        "matchedSamples",
        "readyForAnalysis",
        "sex",
        "tumourSamples",
        "additionalInformation",
        "assignedICD10",
        "center",
        "consentStatus",
        "morphology",
        "primaryDiagnosisDisease",
        "primaryDiagnosisSubDisease",
        "versionControl",
        "yearOfBirth",
    ]

    def __init__(
        self,
        germlineSamples,
        individualId,
        matchedSamples,
        readyForAnalysis,
        sex,
        tumourSamples,
        additionalInformation=None,
        assignedICD10=None,
        center=None,
        consentStatus=None,
        morphology=None,
        primaryDiagnosisDisease=None,
        primaryDiagnosisSubDisease=None,
        versionControl=None,
        yearOfBirth=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_0_3.CancerParticipant model.

        :param germlineSamples:
        :type germlineSamples: list[GermlineSample]
        :param individualId:
            Individual Id
        :type individualId: str
        :param matchedSamples:
        :type matchedSamples: list[MatchedSamples]
        :param readyForAnalysis:
        :type readyForAnalysis: boolean
        :param sex:
            Sex
        :type sex: Sex
        :param tumourSamples:
        :type tumourSamples: list[TumourSample]
        :param additionalInformation:
            We could add a map here to store additional information for example
            URIs to images, ECGs, etc
        :type additionalInformation: None | dict[str, str]
        :param assignedICD10:
            assigned ICD10 code
        :type assignedICD10: None | list[str]
        :param center:
            Center
        :type center: None | str
        :param consentStatus:
            What has this participant consented to?         A participant that has
            been consented to the programme should also have sequence
            data associated with them; however         this needs to
            be programmatically checked
        :type consentStatus: None | ConsentStatus
        :param morphology:
        :type morphology: None | list[str]
        :param primaryDiagnosisDisease:
            This should be an enumeration when it is well defined         blood,
            breast, prostate, colorectal, cll, aml, renal, ovarian,
            skin, lymphNode, bone, saliva //for individual - there
            could be more than I have listed here, in fact there
            definitely will.
        :type primaryDiagnosisDisease: None | list[str]
        :param primaryDiagnosisSubDisease:
            This should be an enumeration when it is well defined         blood,
            breast, prostate, colorectal, cll, aml, renal, ovarian,
            skin, lymphNode, bone, saliva //for individual - there
            could be more than I have listed here, in fact there
            definitely will.
        :type primaryDiagnosisSubDisease: None | list[str]
        :param versionControl:
            Model version number
        :type versionControl: None | VersionControl
        :param yearOfBirth:
        :type yearOfBirth: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.3"
